#import "AppController.h"
#define preferences [NSUserDefaults standardUserDefaults]

@implementation AppController

// when first launched, this routine is called when all objects are created
// and initialized.  It's a chance for us to set things up before the user gets
// control of the UI.
-(void)awakeFromNib
{
	if ( nil == [preferences objectForKey:@"Delta_t"] ) { // if we never used this app
		NSMutableDictionary *defaultPrefs = [NSMutableDictionary dictionary];
		[defaultPrefs setObject:[NSNumber numberWithInt:30] forKey:@"Delta_t"];
		[preferences registerDefaults: defaultPrefs];
		NSLog(@"Registered defaults for swap_files");
	}
	prefs = [preferences retain];   
	[timeSlider setIntValue:[prefs integerForKey:@"Delta_t"]];

	[self update_info];
	[self updateTimer:nil];
}
- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
	//[self setTimer];
}

- (void)setTimer
{
	int newInterval = [timeSlider intValue];
	NSLog(@"Interval : %d\n",newInterval);
	if (timer) {
		[timer invalidate];
		[timer release];
	}
	timer = [NSTimer scheduledTimerWithTimeInterval:newInterval target:self selector:@selector(update_info) userInfo:nil repeats:YES];
	[timer retain];
}

- (IBAction)updateTimer:(id)sender
{
	[majField setStringValue:[NSString stringWithFormat:@"%d",[timeSlider intValue]]];
	[self setTimer];
	// update prefs
	[prefs setObject:[NSNumber numberWithInt:[timeSlider intValue]] forKey:@"Delta_t"];
	[prefs synchronize];
}

- (void)update_info
{
	int valeur;
    NSTask *task = [[NSTask alloc] init];
    NSPipe *newPipe = [NSPipe pipe];
    NSFileHandle *file = [newPipe fileHandleForReading];
    NSData *data = nil;
	NSString *tempString;

    [task setStandardOutput:newPipe];
    [task setStandardError: [task standardOutput]];
    // The path to the binary is the first argument that was passed in
    [task setLaunchPath:@"/bin/sh"];
    [task setArguments:[NSArray arrayWithObjects:@"-c", @"ls -l /var/vm/swap* |wc -l", nil]];
	
    [task launch];
	
	data = [file readDataToEndOfFile];
	
	tempString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
	valeur=[tempString intValue];
	//NSLog(@"contents : %d\n",valeur);
	[textField setStringValue:[NSString stringWithFormat:@"%d",valeur]];
	  
    [task release];
	//[textField setStringValue:[NSString stringWithFormat:@"%d",system("ls -l /var/vm/swap* |wc -l")]];
}

// If the user closes the search window, let's just quit
-(BOOL)windowShouldClose:(id)sender
{
	[NSApp terminate:nil];
	return YES;
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	if (timer) {
		[timer invalidate];
		[timer release];
		timer = nil;
	}
	NSLog(@"Application Uptime will terminate !");
}
@end
